<!DOCTYPE html>
<html lang="en">
<head>
  <title>63.20</title>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản Lý Drink</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label>Mã Nước Uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="inp-drink-code" placeholder="Drink code" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label>Tên Nước Uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="inp-drink-name"  placeholder="Tên nước uống ..." class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="add_data" class="btn btn-success mr-3">Add Data</button>
		  <button id="save_data" class="btn btn-info mr-3">Save Data</button>
		  <button id="delete_data" class="btn btn-warning mr-3">Delete Data</button>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã nước uống</th>
        <th>Tên nước uống</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
	$(document).ready(function(){
		var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maNuocUong"},
				{"data":"tenNuocUong"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
			]
		})

		callAjaxApiGetDrinks();

		function callAjaxApiGetDrinks() {
			$.ajax({
				url: "http://localhost:8080/drinks",
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}
		
		// khi click vào 1 row trong danh sách, sẽ load dữ liệu vào form, bằng cách gọi API (GET)	drinks/:id
		$("#user-table").on("click", "td", function() {
			onTableRowClick(this);
		});

		var gId = 0;

		function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = table.row(vClickedRow).data();
			gId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gId);
			callAjaxApiGetDrinksById(gId);
		}

		function callAjaxApiGetDrinksById(paramId) {
			$.ajax({
				url: "http://localhost:8080/drinks/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadDataDrinkToForm(res);
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		function loadDataDrinkToForm(paramDrink) {
			$("#inp-drink-code").val(paramDrink.maNuocUong);
			$("#inp-drink-name").val(paramDrink.tenNuocUong);
			$("#input-createDate").val(paramDrink.ngayTao);
			$("#input-updateDate").val(paramDrink.ngayCapNhat);
		}

		$("#save_data").on("click", function() {
			if(gId == 0) {
				alert("Chưa chọn loại Drink nào");
			}
			else {
				var vDrinkData = readDataDrinkFromWeb();
				callAjaxApiUpdateDrinkById(gId, vDrinkData);
			}
		})

		function readDataDrinkFromWeb() {
			var vDrinkData = {
				maNuocUong: $("#inp-drink-code").val(),
				tenNuocUong: $("#inp-drink-name").val(),
			};			
			console.log("Thông tin drink đọc được là:");
			console.log(vDrinkData);
			return vDrinkData
		}

		function callAjaxApiUpdateDrinkById(paramId, paramVoucherData) {
			$.ajax({
				url: "http://localhost:8080/drinks/" + paramId,
				type: "PUT",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramVoucherData),
				success: function(res) {
					console.log("Update thành công cho voucher có id " + paramId + ". Response là:");
					console.log(res);
					callAjaxApiGetDrinks();
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		$("#add_data").on("click", function() {
			gId = 0;
			var vDrinkData = readDataDrinkFromWeb();
			callAjaxApiAddNewDrink(vDrinkData);
		})

		function callAjaxApiAddNewDrink(paramVoucherData) {
			$.ajax({
				url: "http://localhost:8080/drinks/",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramVoucherData),
				success: function(res) {
					console.log("Tạo nước uống mới thành công. Response là:");
					console.log(res);
					callAjaxApiGetDrinks();
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		$("#delete_data").on("click", function() {
			if(gId == 0) {
				alert("Chưa chọn loại nước uống nào");
			}
			else {
				callAjaxApiDeleteDrinkById(gId);
			}
		})

		function callAjaxApiDeleteDrinkById(paramId) {
			$.ajax({
				url: "http://localhost:8080/drinks/" + paramId,
				type: "DELETE",
				dataType: "json",
				success: function(res) {
					console.log("Xóa Drink có id " + paramId + " thành công. Response là:");
					console.log(res);
					callAjaxApiGetDrinks();
					gId = 0;
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

	})
</script>
</body>
</html>
